Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -13276,12 +13508,10 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-    arpl word [bx-07083h], cx                 ; 63 8f 7d 8f
-    nop                                       ; 90
-    db  08fh, 0a5h, 08fh, 0b8h
-    ; pop word [di-04771h]                      ; 8f a5 8f b8
-    db  08fh, 0cbh
-    ; pop bx                                    ; 8f cb
-    db  08fh
-_pci16_function:                             ; 0xf8e81 LB 0x1d7
+    mov word [bx+di-06e5dh], dx               ; 89 91 a3 91
+    mov DH, strict byte 091h                  ; b6 91
+    retf                                      ; cb
+    xchg cx, ax                               ; 91
+    ficom word [bx+di-06e0fh]                 ; de 91 f1 91
+_pci16_function:                             ; 0xf90a7 LB 0x1d7
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -13297,17 +13527,17 @@
     xor ah, ah                                ; 30 e4
     cmp bx, strict byte 00003h                ; 83 fb 03
-    jc short 08ebah                           ; 72 1a
-    jbe short 08f12h                          ; 76 70
+    jc short 090e0h                           ; 72 1a
+    jbe short 09138h                          ; 76 70
     cmp bx, strict byte 0000eh                ; 83 fb 0e
-    je near 08fdfh                            ; 0f 84 36 01
+    je near 09205h                            ; 0f 84 36 01
     cmp bx, strict byte 00008h                ; 83 fb 08
-    jc near 09024h                            ; 0f 82 74 01
+    jc near 0924ah                            ; 0f 82 74 01
     cmp bx, strict byte 0000dh                ; 83 fb 0d
-    jbe near 08f37h                           ; 0f 86 80 00
-    jmp near 09024h                           ; e9 6a 01
+    jbe near 0915dh                           ; 0f 86 80 00
+    jmp near 0924ah                           ; e9 6a 01
     cmp bx, strict byte 00002h                ; 83 fb 02
-    je short 08ee2h                           ; 74 23
+    je short 09108h                           ; 74 23
     cmp bx, strict byte 00001h                ; 83 fb 01
-    jne near 09024h                           ; 0f 85 5e 01
+    jne near 0924ah                           ; 0f 85 5e 01
     mov word [bp+020h], strict word 00001h    ; c7 46 20 01 00
     mov word [bp+014h], 00210h                ; c7 46 14 10 02
@@ -13315,49 +13545,49 @@
     mov word [bp+018h], 04350h                ; c7 46 18 50 43
     mov word [bp+01ah], 02049h                ; c7 46 1a 49 20
-    jmp near 09051h                           ; e9 6f 01
+    jmp near 09277h                           ; e9 6f 01
     cmp word [bp+018h], strict byte 0ffffh    ; 83 7e 18 ff
-    jne short 08eeeh                          ; 75 06
+    jne short 09114h                          ; 75 06
     or ah, 083h                               ; 80 cc 83
-    jmp near 0904ah                           ; e9 5c 01
+    jmp near 09270h                           ; e9 5c 01
     mov bx, word [bp+008h]                    ; 8b 5e 08
     mov dx, word [bp+01ch]                    ; 8b 56 1c
     mov ax, word [bp+018h]                    ; 8b 46 18
     xor cx, cx                                ; 31 c9
-    call 08d8ah                               ; e8 8e fe
+    call 08fb0h                               ; e8 8e fe
     cmp ax, strict word 0ffffh                ; 3d ff ff
-    jne short 08f0ch                          ; 75 0b
+    jne short 09132h                          ; 75 0b
     mov ax, word [bp+020h]                    ; 8b 46 20
     xor ah, ah                                ; 30 e4
     or ah, 086h                               ; 80 cc 86
-    jmp near 0904ah                           ; e9 3e 01
+    jmp near 09270h                           ; e9 3e 01
     mov word [bp+014h], ax                    ; 89 46 14
-    jmp near 09051h                           ; e9 3f 01
+    jmp near 09277h                           ; e9 3f 01
     mov bx, word [bp+008h]                    ; 8b 5e 08
     mov ax, word [bp+01ch]                    ; 8b 46 1c
     mov dx, word [bp+01eh]                    ; 8b 56 1e
     mov cx, strict word 00001h                ; b9 01 00
-    call 08d8ah                               ; e8 69 fe
+    call 08fb0h                               ; e8 69 fe
     cmp ax, strict word 0ffffh                ; 3d ff ff
-    jne short 08f31h                          ; 75 0b
+    jne short 09157h                          ; 75 0b
     mov ax, word [bp+020h]                    ; 8b 46 20
     xor ah, ah                                ; 30 e4
     or ah, 086h                               ; 80 cc 86
-    jmp near 0904ah                           ; e9 19 01
+    jmp near 09270h                           ; e9 19 01
     mov word [bp+014h], ax                    ; 89 46 14
-    jmp near 09051h                           ; e9 1a 01
+    jmp near 09277h                           ; e9 1a 01
     cmp word [bp+004h], 00100h                ; 81 7e 04 00 01
-    jc short 08f44h                           ; 72 06
+    jc short 0916ah                           ; 72 06
     or ah, 087h                               ; 80 cc 87
-    jmp near 0904ah                           ; e9 06 01
+    jmp near 09270h                           ; e9 06 01
     mov dx, word [bp+004h]                    ; 8b 56 04
     mov ax, word [bp+014h]                    ; 8b 46 14
-    call 08d66h                               ; e8 19 fe
+    call 08f8ch                               ; e8 19 fe
     mov bx, word [bp+020h]                    ; 8b 5e 20
     xor bh, bh                                ; 30 ff
     sub bx, strict byte 00008h                ; 83 eb 08
     cmp bx, strict byte 00005h                ; 83 fb 05
-    jnbe near 09051h                          ; 0f 87 f5 00
+    jnbe near 09277h                          ; 0f 87 f5 00
     add bx, bx                                ; 01 db
-    jmp word [cs:bx-0718bh]                   ; 2e ff a7 75 8e
+    jmp word [cs:bx-06f65h]                   ; 2e ff a7 9b 90
     mov bx, word [bp+01ch]                    ; 8b 5e 1c
     xor bl, bl                                ; 30 db
@@ -13370,5 +13600,5 @@
     or bx, ax                                 ; 09 c3
     mov word [bp+01ch], bx                    ; 89 5e 1c
-    jmp near 09051h                           ; e9 d4 00
+    jmp near 09277h                           ; e9 d4 00
     mov dx, word [bp+004h]                    ; 8b 56 04
     xor dh, dh                                ; 30 f6
@@ -13377,5 +13607,5 @@
     in ax, DX                                 ; ed
     mov word [bp+01ch], ax                    ; 89 46 1c
-    jmp near 09051h                           ; e9 c1 00
+    jmp near 09277h                           ; e9 c1 00
     mov dx, 00cfch                            ; ba fc 0c
     in eax, DX                                ; 66 ed
@@ -13386,5 +13616,5 @@
     mov word [bp+01ch], ax                    ; 89 46 1c
     mov word [bp+01eh], dx                    ; 89 56 1e
-    jmp near 09051h                           ; e9 ac 00
+    jmp near 09277h                           ; e9 ac 00
     mov ax, word [bp+01ch]                    ; 8b 46 1c
     mov dx, word [bp+004h]                    ; 8b 56 04
@@ -13393,5 +13623,5 @@
     add dx, 00cfch                            ; 81 c2 fc 0c
     out DX, AL                                ; ee
-    jmp near 09051h                           ; e9 99 00
+    jmp near 09277h                           ; e9 99 00
     mov ax, word [bp+01ch]                    ; 8b 46 1c
     mov dx, word [bp+004h]                    ; 8b 56 04
@@ -13400,5 +13630,5 @@
     add dx, 00cfch                            ; 81 c2 fc 0c
     out DX, ax                                ; ef
-    jmp near 09051h                           ; e9 86 00
+    jmp near 09277h                           ; e9 86 00
     mov ax, word [bp+01ch]                    ; 8b 46 1c
     mov cx, word [bp+01eh]                    ; 8b 4e 1e
@@ -13409,12 +13639,12 @@
     ; mov ax, cx                                ; 8b c1
     out DX, eax                               ; 66 ef
-    jmp short 09051h                          ; eb 72
+    jmp short 09277h                          ; eb 72
     mov bx, word [bp+004h]                    ; 8b 5e 04
     mov es, [bp+026h]                         ; 8e 46 26
     mov word [bp-008h], bx                    ; 89 5e f8
     mov [bp-006h], es                         ; 8c 46 fa
-    mov cx, word [word 00000h]                ; 8b 0e 00 00
+    mov cx, word [0f4a0h]                     ; 8b 0e a0 f4
     cmp cx, word [es:bx]                      ; 26 3b 0f
-    jbe short 09005h                          ; 76 11
+    jbe short 0922bh                          ; 76 11
     mov ax, word [bp+020h]                    ; 8b 46 20
     xor ah, ah                                ; 30 e4
@@ -13422,5 +13652,5 @@
     mov word [bp+020h], ax                    ; 89 46 20
     or word [bp+02ch], strict byte 00001h     ; 83 4e 2c 01
-    jmp short 09019h                          ; eb 14
+    jmp short 0923fh                          ; eb 14
     les di, [es:bx+002h]                      ; 26 c4 7f 02
     mov si, 0f2c0h                            ; be c0 f2
@@ -13431,12 +13661,12 @@
     pop DS                                    ; 1f
     mov word [bp+014h], 00a00h                ; c7 46 14 00 0a
-    mov ax, word [00000h]                     ; a1 00 00
+    mov ax, word [0f4a0h]                     ; a1 a0 f4
     les bx, [bp-008h]                         ; c4 5e f8
     mov word [es:bx], ax                      ; 26 89 07
-    jmp short 09051h                          ; eb 2d
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp short 09277h                          ; eb 2d
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 9d 88
+    call 018e1h                               ; e8 8c 86
     mov ax, word [bp+014h]                    ; 8b 46 14
     push ax                                   ; 50
@@ -13445,5 +13675,5 @@
     push 00d5eh                               ; 68 5e 0d
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 ce 88
+    call 01922h                               ; e8 bd 86
     add sp, strict byte 00008h                ; 83 c4 08
     mov ax, word [bp+020h]                    ; 8b 46 20
@@ -13457,5 +13687,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-pci_find_classcode_:                         ; 0xf9058 LB 0x2b
+pci_find_classcode_:                         ; 0xf927e LB 0x2b
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -13472,5 +13702,5 @@
     int 01ah                                  ; cd 1a
     cmp ah, 000h                              ; 80 fc 00
-    je near 09079h                            ; 0f 84 03 00
+    je near 0929fh                            ; 0f 84 03 00
     mov bx, strict word 0ffffh                ; bb ff ff
     mov ax, bx                                ; 89 d8
@@ -13481,5 +13711,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-pci_read_config_byte_:                       ; 0xf9083 LB 0x24
+pci_read_config_byte_:                       ; 0xf92a9 LB 0x24
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -13500,5 +13730,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-pci_read_config_word_:                       ; 0xf90a7 LB 0x22
+pci_read_config_word_:                       ; 0xf92cd LB 0x22
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -13519,5 +13749,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-pci_read_config_dword_:                      ; 0xf90c9 LB 0x27
+pci_read_config_dword_:                      ; 0xf92ef LB 0x27
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -13540,5 +13770,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-vds_is_present_:                             ; 0xf90f0 LB 0x1d
+vds_is_present_:                             ; 0xf9316 LB 0x1d
     push bx                                   ; 53
     push bp                                   ; 55
@@ -13548,5 +13778,5 @@
     mov es, ax                                ; 8e c0
     test byte [es:bx], 020h                   ; 26 f6 07 20
-    je short 09108h                           ; 74 06
+    je short 0932eh                           ; 74 06
     mov ax, strict word 00001h                ; b8 01 00
     pop bp                                    ; 5d
@@ -13557,5 +13787,5 @@
     pop bx                                    ; 5b
     retn                                      ; c3
-vds_real_to_lin_:                            ; 0xf910d LB 0x1e
+vds_real_to_lin_:                            ; 0xf9333 LB 0x1e
     push bx                                   ; 53
     push cx                                   ; 51
@@ -13568,5 +13798,5 @@
     sal ax, 1                                 ; d1 e0
     rcl dx, 1                                 ; d1 d2
-    loop 0911bh                               ; e2 fa
+    loop 09341h                               ; e2 fa
     xor cx, cx                                ; 31 c9
     add ax, bx                                ; 01 d8
@@ -13576,5 +13806,5 @@
     pop bx                                    ; 5b
     retn                                      ; c3
-vds_build_sg_list_:                          ; 0xf912b LB 0x79
+vds_build_sg_list_:                          ; 0xf9351 LB 0x79
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -13590,21 +13820,21 @@
     mov bx, word [bp+006h]                    ; 8b 5e 06
     mov word [es:di+002h], bx                 ; 26 89 5d 02
-    call 0910dh                               ; e8 c3 ff
+    call 09333h                               ; e8 c3 ff
     mov es, si                                ; 8e c6
     mov word [es:di+004h], ax                 ; 26 89 45 04
     mov word [es:di+006h], dx                 ; 26 89 55 06
     mov word [es:di+008h], strict word 00000h ; 26 c7 45 08 00 00
-    call 090f0h                               ; e8 93 ff
+    call 09316h                               ; e8 93 ff
     test ax, ax                               ; 85 c0
-    je short 09174h                           ; 74 13
+    je short 0939ah                           ; 74 13
     mov es, si                                ; 8e c6
     mov ax, 08105h                            ; b8 05 81
     mov dx, strict word 00000h                ; ba 00 00
     int 04bh                                  ; cd 4b
-    jc near 09171h                            ; 0f 82 02 00
+    jc near 09397h                            ; 0f 82 02 00
     db  032h, 0c0h
     ; xor al, al                                ; 32 c0
     cbw                                       ; 98
-    jmp short 0919bh                          ; eb 27
+    jmp short 093c1h                          ; eb 27
     mov es, si                                ; 8e c6
     mov word [es:di+00eh], strict word 00001h ; 26 c7 45 0e 01 00
@@ -13623,5 +13853,5 @@
     pop bp                                    ; 5d
     retn 00004h                               ; c2 04 00
-vds_free_sg_list_:                           ; 0xf91a4 LB 0x3c
+vds_free_sg_list_:                           ; 0xf93ca LB 0x36
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -13629,7 +13859,7 @@
     push di                                   ; 57
     mov bx, ax                                ; 89 c3
-    call 090f0h                               ; e8 42 ff
+    call 09316h                               ; e8 42 ff
     test ax, ax                               ; 85 c0
-    je short 091c5h                           ; 74 13
+    je short 093ebh                           ; 74 13
     mov di, bx                                ; 89 df
     mov es, dx                                ; 8e c2
@@ -13637,5 +13867,5 @@
     mov dx, strict word 00000h                ; ba 00 00
     int 04bh                                  ; cd 4b
-    jc near 091c4h                            ; 0f 82 02 00
+    jc near 093eah                            ; 0f 82 02 00
     db  032h, 0c0h
     ; xor al, al                                ; 32 c0
@@ -13648,6 +13878,6 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-    times 0xc db 0
-__U4D:                                       ; 0xf91e0 LB 0x39
+    times 0x6 db 0
+__U4D:                                       ; 0xf9400 LB 0x39
     pushfw                                    ; 9c
     push eax                                  ; 66 50
@@ -13679,5 +13909,5 @@
     popfw                                     ; 9d
     retn                                      ; c3
-__U4M:                                       ; 0xf9219 LB 0x31
+__U4M:                                       ; 0xf9439 LB 0x31
     pushfw                                    ; 9c
     push eax                                  ; 66 50
@@ -13704,5 +13934,5 @@
     popfw                                     ; 9d
     retn                                      ; c3
-_fmemset_:                                   ; 0xf924a LB 0xd
+_fmemset_:                                   ; 0xf946a LB 0xd
     push di                                   ; 57
     mov es, dx                                ; 8e c2
@@ -13714,5 +13944,5 @@
     pop di                                    ; 5f
     retn                                      ; c3
-_fmemcpy_:                                   ; 0xf9257 LB 0x33
+_fmemcpy_:                                   ; 0xf9477 LB 0x33
     push bp                                   ; 55
     db  08bh, 0ech
@@ -13734,24 +13964,20 @@
     leave                                     ; c9
     retn                                      ; c3
-    add byte [bx+si-05d6eh], ah               ; 00 a0 92 a2
-    xchg dx, ax                               ; 92
-    cmpsb                                     ; a6
-    xchg dx, ax                               ; 92
-    cmpsb                                     ; a6
-    xchg dx, ax                               ; 92
-    cmpsb                                     ; a6
-    xchg dx, ax                               ; 92
-    test AL, strict byte 092h                 ; a8 92
-    test AL, strict byte 092h                 ; a8 92
-    stosb                                     ; aa
-    xchg dx, ax                               ; 92
-    scasb                                     ; ae
-    xchg dx, ax                               ; 92
-    scasb                                     ; ae
-    xchg dx, ax                               ; 92
-    mov AL, strict byte 092h                  ; b0 92
-    mov CH, strict byte 092h                  ; b5 92
-    mov BH, strict byte 092h                  ; b7 92
-apm_worker:                                  ; 0xf928a LB 0x3a
+    add al, al                                ; 00 c0
+    xchg sp, ax                               ; 94
+    retn 0c694h                               ; c2 94 c6
+    xchg sp, ax                               ; 94
+    db  0c6h, 094h, 0c6h, 094h, 0c8h
+    ; mov byte [si-06b3ah], 0c8h                ; c6 94 c6 94 c8
+    xchg sp, ax                               ; 94
+    enter 0ca94h, 094h                        ; c8 94 ca 94
+    into                                      ; ce
+    xchg sp, ax                               ; 94
+    into                                      ; ce
+    xchg sp, ax                               ; 94
+    rcl byte [si-06b2bh], 1                   ; d0 94 d5 94
+    xlatb                                     ; d7
+    xchg sp, ax                               ; 94
+apm_worker:                                  ; 0xf94aa LB 0x3a
     sti                                       ; fb
     push ax                                   ; 50
@@ -13765,21 +13991,21 @@
     pop ax                                    ; 58
     mov AH, strict byte 053h                  ; b4 53
-    jnc short 092c0h                          ; 73 25
-    jmp word [cs:bp-06d90h]                   ; 2e ff a6 70 92
-    jmp short 092beh                          ; eb 1c
+    jnc short 094e0h                          ; 73 25
+    jmp word [cs:bp-06b70h]                   ; 2e ff a6 90 94
+    jmp short 094deh                          ; eb 1c
     sti                                       ; fb
     hlt                                       ; f4
-    jmp short 092beh                          ; eb 18
-    jmp short 092beh                          ; eb 16
-    jmp short 092c0h                          ; eb 16
+    jmp short 094deh                          ; eb 18
+    jmp short 094deh                          ; eb 16
+    jmp short 094e0h                          ; eb 16
     mov AH, strict byte 080h                  ; b4 80
-    jmp short 092c2h                          ; eb 14
-    jmp short 092c0h                          ; eb 10
+    jmp short 094e2h                          ; eb 14
+    jmp short 094e0h                          ; eb 10
     mov ax, 00102h                            ; b8 02 01
-    jmp short 092beh                          ; eb 09
-    jmp short 092beh                          ; eb 07
+    jmp short 094deh                          ; eb 09
+    jmp short 094deh                          ; eb 07
     mov BL, strict byte 000h                  ; b3 00
     mov cx, strict word 00000h                ; b9 00 00
-    jmp short 092beh                          ; eb 00
+    jmp short 094deh                          ; eb 00
     clc                                       ; f8
     retn                                      ; c3
@@ -13787,5 +14013,5 @@
     stc                                       ; f9
     retn                                      ; c3
-apm_pm16_entry:                              ; 0xf92c4 LB 0x11
+apm_pm16_entry:                              ; 0xf94e4 LB 0x11
     mov AH, strict byte 002h                  ; b4 02
     push DS                                   ; 1e
@@ -13795,11 +14021,11 @@
     add bp, strict byte 00008h                ; 83 c5 08
     mov ds, bp                                ; 8e dd
-    call 0928ah                               ; e8 b8 ff
+    call 094aah                               ; e8 b8 ff
     pop bp                                    ; 5d
     pop DS                                    ; 1f
     retf                                      ; cb
 
-  ; Padding 0x472b bytes at 0xf92d5
-  times 18219 db 0
+  ; Padding 0x450b bytes at 0xf94f5
+  times 17675 db 0
 
 section BIOS32 progbits vstart=0xda00 align=1 ; size=0x3cb class=CODE group=AUTO
@@ -13848,5 +14074,5 @@
     add bp, strict byte 00008h                ; 83 c5 08
     push ebp                                  ; 66 55
-    mov bp, 092c6h                            ; bd c6 92
+    mov bp, 094e6h                            ; bd e6 94
     add byte [bx+si], al                      ; 00 00
     push ebp                                  ; 66 55
@@ -14180,8 +14406,7 @@
     mov bx, ax                                ; 89 c3
     mov edx, dword [di]                       ; 66 8b 15
-    add byte [bx+si], al                      ; 00 00
-    add byte [bx+si], al                      ; 00 00
-    db  066h, 026h, 03bh, 010h
-    ; cmp edx, dword [es:bx+si]                 ; 66 26 3b 10
+    mov AL, byte [000f4h]                     ; a0 f4 00
+    add byte [bp+026h], ah                    ; 00 66 26
+    cmp dx, word [bx+si]                      ; 3b 10
     jbe short 0dd7eh                          ; 76 12
     mov ax, word [di+024h]                    ; 8b 45 24
@@ -14207,7 +14432,6 @@
     pop DS                                    ; 1f
     mov dword [di+018h], strict dword 0a1660a00h ; 66 c7 45 18 00 0a 66 a1
-    add byte [bx+si], al                      ; 00 00
-    add byte [bx+si], al                      ; 00 00
-    mov es, [di-010h]                         ; 8e 45 f0
+    mov AL, byte [000f4h]                     ; a0 f4 00
+    add byte [bp-00fbbh], cl                  ; 00 8e 45 f0
     db  066h, 026h, 089h, 003h
     ; mov dword [es:bp+di], eax                 ; 66 26 89 03
@@ -14342,5 +14566,5 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 01712h                               ; e8 27 36
+    call 01727h                               ; e8 3c 36
     call 0e8e0h                               ; e8 f2 07
     db  033h, 0dbh
@@ -14356,4 +14580,8 @@
     mov ax, 0027fh                            ; b8 7f 02
     mov word [00413h], ax                     ; a3 13 04
+    mov ax, 0e9dch                            ; b8 dc e9
+    mov word [00018h], ax                     ; a3 18 00
+    mov ax, 0f000h                            ; b8 00 f0
+    mov word [0001ah], ax                     ; a3 1a 00
     mov ax, 0f84dh                            ; b8 4d f8
     mov word [00044h], ax                     ; a3 44 00
@@ -14384,5 +14612,5 @@
     mov ax, 0f000h                            ; b8 00 f0
     mov word [00072h], ax                     ; a3 72 00
-    call 0e7c0h                               ; e8 5c 06
+    call 0e7c0h                               ; e8 50 06
     mov ax, 0fea5h                            ; b8 a5 fe
     mov word [00020h], ax                     ; a3 20 00
@@ -14422,5 +14650,5 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 04945h                               ; e8 7e 67
+    call 04964h                               ; e8 91 67
     pop DS                                    ; 1f
     mov AL, strict byte 014h                  ; b0 14
@@ -14439,7 +14667,7 @@
     mov CL, strict byte 014h                  ; b1 14
     mov dx, 00378h                            ; ba 78 03
-    call 0ecedh                               ; e8 02 0b
+    call 0ecedh                               ; e8 f6 0a
     mov dx, 00278h                            ; ba 78 02
-    call 0ecedh                               ; e8 fc 0a
+    call 0ecedh                               ; e8 f0 0a
     sal bx, 00eh                              ; c1 e3 0e
     mov ax, word [00410h]                     ; a1 10 04
@@ -14464,11 +14692,11 @@
     mov CL, strict byte 00ah                  ; b1 0a
     mov dx, 003f8h                            ; ba f8 03
-    call 0ed0bh                               ; e8 de 0a
+    call 0ed0bh                               ; e8 d2 0a
     mov dx, 002f8h                            ; ba f8 02
-    call 0ed0bh                               ; e8 d8 0a
+    call 0ed0bh                               ; e8 cc 0a
     mov dx, 003e8h                            ; ba e8 03
-    call 0ed0bh                               ; e8 d2 0a
+    call 0ed0bh                               ; e8 c6 0a
     mov dx, 002e8h                            ; ba e8 02
-    call 0ed0bh                               ; e8 cc 0a
+    call 0ed0bh                               ; e8 c0 0a
     sal bx, 009h                              ; c1 e3 09
     mov ax, word [00410h]                     ; a1 10 04
@@ -14489,5 +14717,5 @@
     mov ax, 0f000h                            ; b8 00 f0
     mov word [001c2h], ax                     ; a3 c2 01
-    call 0edbfh                               ; e8 4b 0b
+    call 0edbfh                               ; e8 3f 0b
     mov ax, 0f8a9h                            ; b8 a9 f8
     mov word [001d0h], ax                     ; a3 d0 01
@@ -14502,10 +14730,10 @@
     mov ax, 0f000h                            ; b8 00 f0
     mov word [00042h], ax                     ; a3 42 00
-    call 0e79bh                               ; e8 00 05
-    call 0f13ch                               ; e8 9e 0e
-    call 0f1c1h                               ; e8 20 0f
-    call 0e758h                               ; e8 b4 04
-    jmp short 0e31bh                          ; eb 75
-    times 0x1b db 0
+    call 0e79bh                               ; e8 f4 04
+    call 0f13ch                               ; e8 92 0e
+    call 0f1c1h                               ; e8 14 0f
+    call 0e758h                               ; e8 a8 04
+    jmp short 0e31bh                          ; eb 69
+    times 0xf db 0
     db  'XM'
 nmi:                                         ; 0xfe2c3 LB 0x7
@@ -14513,5 +14741,5 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 016eeh                               ; e8 25 34
+    call 01703h                               ; e8 3a 34
     iret                                      ; cf
 int75_handler:                               ; 0xfe2ca LB 0x8
@@ -14551,8 +14779,8 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 01b48h                               ; e8 27 38
-    call 01f42h                               ; e8 1e 3c
-    call 08b3ah                               ; e8 13 a8
-    call 07c11h                               ; e8 e7 98
+    call 01b5dh                               ; e8 3c 38
+    call 01f57h                               ; e8 33 3c
+    call 08d60h                               ; e8 39 aa
+    call 07e37h                               ; e8 0d 9b
     call 0ed2fh                               ; e8 02 0a
     call 0e2d2h                               ; e8 a2 ff
@@ -14560,6 +14788,6 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 01732h                               ; e8 fc 33
-    call 03629h                               ; e8 f0 52
+    call 01747h                               ; e8 11 34
+    call 03648h                               ; e8 0f 53
     sti                                       ; fb
     int 019h                                  ; cd 19
@@ -14659,5 +14887,5 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 05cd7h                               ; e8 95 75
+    call 05cf6h                               ; e8 b4 75
     popaw                                     ; 61
     pop ES                                    ; 07
@@ -14670,5 +14898,5 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 01683h                               ; e8 34 2f
+    call 01698h                               ; e8 49 2f
     popaw                                     ; 61
     pop ES                                    ; 07
@@ -14775,5 +15003,5 @@
     pop DS                                    ; 1f
     cld                                       ; fc
-    call 05045h                               ; e8 03 68
+    call 05064h                               ; e8 22 68
     popaw                                     ; 61
     pop DS                                    ; 1f
